#!/usr/bin/env python
# -*- coding: UTF-8 -*-

import sys
import re
import pygtk
pygtk.require("2.0")
import gtk.glade
import os
import string
import gobject

#texto de los RadioButton
MENSAJE_TODA = "Compartir impresora con toda la red"
MENSAJE_IP = "Compartir impresora por IP"
MENSAJE_NO = "Dejar de compartir impresora"
DIRECTORIO ="/usr/local/cga-comparte-impresora/"
DIR_CUPSD ="/etc/cups/"
# posiciones de los RadioButton
POSX1 = 10
POSY1 = 20
POSX2= 10
POSY2= 65
POSX3= 10
POSY3= 43

class CVentanaMenu:

	def __init__(self):
		self.gladefile = DIRECTORIO+"glade/comparte-impresora.glade"
		self.wTree = gtk.glade.XML(self.gladefile)

		#diccionario para relacionar eventos con funciones manejadoras
		dic = {	"on_aceptar_clicked" : self.campo_elegido, #menu inicio,boton aceptar
				"on_button2_clicked" : self.cerrar_menu, #menu inicio, boton salir
				"cerrar_ventanaIPS": self.cerrar_ventanaIp, #asociamos el 
				"on_aceptar_mensaje_clicked" : self.cerrar_mensaje, #ventana mensaje
				"on_mensaje_delete_event":self.cerrar_mensaje,
				"on_mensaje_delete_event" : self.cerrar_mensaje,
				"on_salir_error_clicked": self.cerrar_ventana_error_impresora, #boton aceptar de la ventana mensaje
				"on_error_delete_event" : self.cerrar_ventana_error_impresora,
				"on_menu_delete_event": self.cerrar_menu,
				
		}

		#se conecta cada señal con la fucnión manejadora
		self.wTree.signal_autoconnect(dic)
		
		# Se sacan del wTree que relaciona con glade los objetos correspondientes
		self.ventana_mensaje = self.wTree.get_widget('mensaje')
		self.ventana_mensaje.set_icon_from_file("/usr/share/pixmaps/printercomp.png")
		
		#tag de la ventana mensaje
		self.texto_info = self.wTree.get_widget('texto_info')
		#tag del estado
		self.etiqueta_estado = self.wTree.get_widget('tag_estado')
		#ventana de ips
		self.ventana_ip = self.wTree.get_widget('ventanaIPS')
		#obtengo el widget fixed4 del gladefile
		self.fixed_menu = self.wTree.get_widget('fixed4')


		#
		#	Este objeto sera el encargado de modificar el fichero cupsd.conf
		#
		self.o_fichero = Cfichero_cupsd()


	def pintar_botones(self):
		self.leer_estado()
		#no compartiendo
		if self.estado == '0':
			#edito el texto del tag etiueta_estado
			self.etiqueta_estado.set_text("No se esta compartiendo\nla impresora")

			#no se esta compartiendo
			self.boton_compartir_red = gtk.RadioButton(group = None, label= MENSAJE_TODA)
			#coloco el boton_compartir_red en el fixed_menu en sus cordendas
			self.fixed_menu.put(self.boton_compartir_red,POSX1,POSY1)
			#se activa esta opcion al inicio
			self.boton_compartir_red.set_active(True)

			#creo los demas botones indicandoles como grupo el primer boton
			self.boton_compartir_ip = gtk.RadioButton(group=self.boton_compartir_red, label = MENSAJE_IP)
			#coloco el boton en el fixed_menu con sus coordenadas
			self.fixed_menu.put(self.boton_compartir_ip,POSX2,POSY2)

			# edito el texto del tag texto_info
			self.texto_info.set_text("En este momento no se esta compartiendo las impresoras")

			#muestro los botones creados
			self.boton_compartir_red.show()
			self.boton_compartir_ip.show()

		#compartiendo con toda la red
		elif self.estado == '1':
			#edito el texto del tag etiqueta_estado
			self.etiqueta_estado.set_text("Se esta compartiendo la impresora\n con toda la red")

			#creo  boton_no_compartir tipo RadioButton
			self.boton_no_compartir = gtk.RadioButton(group = None, label= MENSAJE_NO)
			#se activa este boton al inicio
			self.boton_no_compartir.set_active(True)

			#colo el boton en el fixed_menu
			self.fixed_menu.put(self.boton_no_compartir,POSX3,POSY3)
			#hago visible el boton creado
			self.boton_no_compartir.show()

			#se edita el texto el tag texto_info
			self.texto_info.set_text("En este momento no se estan compartiendo impresoras")

		#compartiendo por ip
		elif self.estado == '2':
            #edito el texto del tag etiqueta_estado
			self.etiqueta_estado.set_text("Se esta compartiendo la impresora\n con algunas ips")

			#creo el primer boton
			self.boton_compartir_red = gtk.RadioButton(group = None, label=MENSAJE_TODA)
			#lo coloco en el fixed_menu con coordenadas
			self.fixed_menu.put(self.boton_compartir_red,POSX1,POSY1-10)


			#se crea el segundo boton
			self.boton_no_compartir = gtk.RadioButton(group = self.boton_compartir_red, label = MENSAJE_NO)
			#lo coloco en el fixed_menu
			self.fixed_menu.put(self.boton_no_compartir,POSX2,POSY2-17)

			#creo el boton para ir al menu de ips
			self.boton_menu_ip = gtk.RadioButton(group = self.boton_compartir_red,label = "Ir a menu de seleccion de IPs")
			#sera el activo al incio
			self.boton_menu_ip.set_active(True)
			#lo coloco en el fixed_menu
			self.fixed_menu.put(self.boton_menu_ip,POSX2,POSY2+20)


			#se muestran los botones
			self.boton_compartir_red.show()
			self.boton_no_compartir.show()
			self.boton_menu_ip.show()
			#edito el texto del tag texto_info
			self.texto_info.set_text("En este momento se están compartiendo impresora por IP")

		#se muestra la ventana y el texto de info
		self.ventana_menu.show()
		self.texto_info.show()

	# selecciona, dependiendo del estado, el boton activo y cambia el estado
	# se hace selectivo dado que dependiendo de cada estado, existiran o no los botones
	def campo_elegido(self, widget):
		#ventana de mensaje
		if self.ventana_mensaje is None:
			print "El objeto no existe"
			self.ventana_mensaje = self.wTree.get_widget('mensaje')
			self.ventana_mensaje.set_icon_from_file("/usr/share/pixmaps/printercomp.png")
			
		self.leer_estado()
		if self.estado == '0':
			if self.boton_compartir_red.get_active():
				self.cambiar_estado('1')
				self.texto_info.set_text("Se esta compartiendo \n con toda la red")
				self.ventana_mensaje.set_transient_for(self.ventana_menu)
				self.ventana_mensaje.show()
			elif self.boton_compartir_ip.get_active():
				#borramos el archivo lista_ips.txt
				f = open (DIRECTORIO+'lista_ips.txt','w')
				f.write('')
				f.close()
				#establecer el texto de la ventana de informacion
				self.texto_info.set_text("Se esta compartiendo \n por ip")
				#mostrar ventana para compartir ip
				self.abrir_ventana_ip()
		elif self.estado == '1':
			if self.boton_no_compartir.get_active():
			#no compartir
				self.texto_info.set_text("Se ha dejado de \n compartir la(s) impresora(s)")
				self.cambiar_estado('0')
				self.ventana_mensaje.set_transient_for(self.ventana_menu)
				self.ventana_mensaje.show()
		elif self.estado == '2':
			if self.boton_no_compartir.get_active():
				self.texto_info.set_text("Se ha dejado de \n compartir la(s) impresora(s)")
				self.cambiar_estado('0')
				self.ventana_mensaje.set_transient_for(self.ventana_menu)
				self.ventana_mensaje.show()
			elif self.boton_compartir_red.get_active():
				self.texto_info.set_text("Se esta compartiendo \n con toda la red")
				self.cambiar_estado('1')
				self.ventana_mensaje.set_transient_for(self.ventana_menu)
				self.ventana_mensaje.show()
			elif self.boton_menu_ip.get_active():
				#mostrar ventana compartir ip
				self.abrir_ventana_ip()

	#lee del fichero compartiendo que indica le estado de la impresora
	def leer_estado(self):
		self.f1 = open(DIRECTORIO+"compartiendo",'r')
		self.estado =string.strip(self.f1.read())
		self.f1.close()
		return

	#escribe en compartiendo cuando se actualiza el estado de la impresora
	def cambiar_estado(self, nuevo_estado):
		self.borrar_botones()
		#primero borramos los botones presentes
		self.o_fichero.cambiar_cupsd(nuevo_estado)
		#pasamos a cambiar_cupsd el estado actual y al que queremos pasar
		self.f1 = open(DIRECTORIO+"compartiendo",'w')
		self.f1.write(nuevo_estado)
		self.f1.close()
		self.estado = nuevo_estado
		return

	#dependiendo del estado en el que estamos borraremos los botones
	def borrar_botones(self):
		if self.estado == '1' or self.estado == '2' :
			#no se esta compartiendo
			self.boton_no_compartir.destroy()
		if self.estado == '0' or self.estado == '2':
			#compartiendo por red
			self.boton_compartir_red.destroy()
		if self.estado == '0':
			#compartiendo por ip
			self.boton_compartir_ip.destroy()
		if self.estado == '2':
			self.boton_menu_ip.destroy()
		return

	# volver del mensaje al menú pintando los botones según la opción elegida
	def cerrar_mensaje (self,widget,data=None):
		self.buscar_impresora()
		self.ventana_mensaje.hide()
		return True
	
	# vuelve de la ventana de compartir ip y pinta botones
	def cerrar_ventanaIp(self,widget,data=None):
		self.buscar_impresora()
		self.ventana_ip.hide()
		return True
	#funcion para salir de la aplicacion
	def cerrar_menu(self, widget, data=None):
		gtk.main_quit()
		return False

	# llamaremos a la funcion cada vez que cambiemos de modo
	# si no hay una impresora conectada da error y se cierra el programa
	def buscar_impresora(self):
		data = os.popen('lsusb -v | grep Printer|wc -l').read()
		lineas = int (data)
		if lineas == 0 :
			#crea la ventana de error y la muestra
			self.ventana_error_impresora = self.wTree.get_widget('ventana_error_impresora')
			self.ventana_error_impresora.set_icon_from_file('/usr/share/pixmaps/printercomp.png')
			self.ventana_error_impresora.show()
		else:
			#ventana del menu
			self.ventana_menu = self.wTree.get_widget('menu')
			# establecemos el icono de la ventana
			self.ventana_menu.set_icon_from_file("/usr/share/pixmaps/printercomp.png")
			#la entrada al programa es esta
			self.pintar_botones()
			self.ventana_menu.show()
	
	# funcion para cerrar la ventana de error y salir
	# esta funcion esta asociada al evento delte_event, se devuelve
	# true para indicar que SI se quiere cerrar la ventana
	def cerrar_ventana_error_impresora (self,widget,data=None):
		self.ventana_error_impresora.hide()
		gtk.main_quit()
		return True

	# se llama al constructor para abrir la ventana
	# para compartir por ip
	def abrir_ventana_ip(self):
		#se abre la ventana con el objeto
		myGUI = GUI_Controller()
#		myGUI.run()

#clase para manejar el fichero cupsd.conf
class Cfichero_cupsd:

	def __init__(self):
		self.cupsd_file = DIR_CUPSD+"cga-cupds.conf"
		self.leer_estado()

	#funcion similar a la de la clase anterior para leer estado
	def leer_estado(self):
		f1 = open(DIRECTORIO+"compartiendo",'r')
		self.estado =string.strip(f1.read())
		f1.close()

	def cambiar_cupsd (self, nuevo):
		self.leer_estado()
		if nuevo == '0':
			self.no_compartir()
			print "Ejecutamos no_compartir"
		elif nuevo == '1':
			self.compartir_todos()
		#una vez modificado el cupsd.conf reiniciamos cupsys
		os.system("/etc/init.d/cups restart")

	# pasamos a NO COMPARTIR
	# hay que diferenciar si venimos de compartir_todas
	# o de comaprtir_ip
	
	def no_compartir(self):
  		script = DIRECTORIO + "scripts/no_compartir.sh"
		os.system(script)

	# ejecuta el script para publicar interfaces activas
	def compartir_todos(self):
		script = DIRECTORIO+'scripts/publicar_interfaces.sh'
		os.system(script)


class InfoModel:
	""" The model class holds the information we want to display """
	def __init__(self):
		""" Sets up and populates our gtk.TreeStore """
		#creamos un TreeStore con dos columnas
		self.tree_store = gtk.TreeStore( gobject.TYPE_STRING,gobject.TYPE_BOOLEAN )

		# colocar las ips de lista_ips.txt en el TreeStore
		f = open(DIRECTORIO+'lista_ips.txt','r')
		for line in f.readlines():
			parent = self.tree_store.append(None, (line ,None))
		f.close()
		return

	def get_model(self):
		""" Returns the model """
		if self.tree_store:
			return self.tree_store
		else:
			return None

class DisplayModel:
	""" Displays the Info_Model model in a view """

	def make_view( self, model ):
		""" Form a view for the Tree Model """

		#creamos el TreeView a partir del TreeStore y le damos tamano
		self.view = gtk.TreeView( model )
		self.view.set_property('width_request',140)
		self.view.set_property('height_request',-1)

		# configuramos el visualizador de celda de texto y permitimos
		self.renderer = gtk.CellRendererText()

		# Se configura el visualizador de botones biestado y permitimos que se
		# pueda cambiar por el usuario.
		self.renderer1 = gtk.CellRendererToggle()
 		self.renderer1.set_property('activatable', True)
 		# Asociamos la funcion al evento 'toggled'
 		self.renderer1.connect('toggled', self.col1_toggled_cb, model )

 		# Conectamos la columna 0 de la visualización con la columna o de nuestro modelo
		# El visualizador mostrará lo que haya en la columna 0
		# de nuestro modelo.
		self.column0 = gtk.TreeViewColumn("IP", self.renderer, text=0)
		self.column0.set_sizing(gtk.TREE_VIEW_COLUMN_FIXED)
		self.column0.set_fixed_width(120)

		# El estado de activación del modelo se vincula a la segunda columna
		# del modelo. Así, cuando el modelo dice True entonces el botón
		# se mostrará activo, es decir, encendido.
		self.column1 = gtk.TreeViewColumn("Borrar", self.renderer1 )
		self.column1.add_attribute( self.renderer1, "active", 1)
		self.column1.set_sizing(gtk.TREE_VIEW_COLUMN_FIXED)
		self.column1.set_fixed_width(20)

		self.view.append_column( self.column0 )
		self.view.append_column( self.column1 )

		# Devolvemos el TreeView
		return self.view

	# funcion para cambiar el valor de la columna al ser pulsada
	def col1_toggled_cb( self, cell, path, model ):
		"""
		Establece el estado del boton de la columna1 a true o false.
		"""
		model[path][1] = not model[path][1]
		return


#con esta clase manejaremos el treeview
class GUI_Controller:
	""" La clase GUI será la que controle nuestro TreeView """
	def __init__(self):

		self.store = InfoModel()

		self.display = DisplayModel()

		#indicamos la ruta del fichero glade
		self.gladefile = DIRECTORIO + "glade/comparte-impresora.glade"
		self.wTree = gtk.glade.XML(self.gladefile)
		
		#sacamos la ventana
		self.ventana_ip = self.wTree.get_widget('ventanaIPS')
		self.ventana_ip.set_icon_from_file("/usr/share/pixmaps/printercomp.png")

		# sacamos del wTree el campo del tag para comprobar que la ip es valida
		self.campo_ip = self.wTree.get_widget('campo_ip')
		
		# sacamos la ventana error del wTree
		self.ventana_error_ip = self.wTree.get_widget('error_ip')
		self.ventana_error_ip.set_icon_from_file("/usr/share/pixmaps/printercomp.png")
		self.ventana_error_ip.set_transient_for(OIniciar.ventana_menu)

		# sacamos el contenedor para fijar luego el treeview
		self.fixed14 = self.wTree.get_widget('fixed14')
		self.etiqueta_error_ip = self.wTree.get_widget('label9')

		# creamos un diccionario para relacionar las señales
		dic = {	"on_aplicar_clicked" : self.aplicar_cambios,
				"on_atras_clicked" : self.atras,
				"on_anadir_clicked": self.anadir,
				"on_cerrar_ventana_ip_clicked": self.cerrar_ventana_error_ip,
				"on_error_ip_delete_event": self.cerrar_ventana_error_ip,
				
		}

		self.wTree.signal_autoconnect(dic)

		# Obtener el modelo y vincularlo a la vista
		self.mdl = self.store.get_model()
		self.view = self.display.make_view( self.mdl )

		# Añadir la vista a la ScrolledWindow
		self.scrolled_window = gtk.ScrolledWindow()
		# Establecemos que el scroll horizontal nunca se active
		# Y siempre el scroll vertical
		self.scrolled_window.set_policy(gtk.POLICY_NEVER,gtk.POLICY_ALWAYS)
		# Añadimos el TreeView al ScrolledWindow
		self.scrolled_window.add_with_viewport(self.view)
		self.scrolled_window.set_size_request(220, 160)
		# Añadimos el ScrolledWindow en el Fixed14
		self.fixed14.put(self.scrolled_window, 0, 0)
		# Todo Visible!!
		self.scrolled_window.show()
		self.ventana_ip.set_transient_for(OIniciar.ventana_menu)
		self.ventana_ip.show_all()
		return


	# Funcion asociada al click del boton Aplicar
	# Se encarga de Borrar los marcados
	# y los no marcados los añade a lista_
	def aplicar_cambios(self,widget,data=None):
		self.store1 = self.store.get_model()
		treeiter = self.store1.get_iter_first()
		while treeiter:
			# Leemos con el TreeIter a partir de la fila 0
			# sacando los valores: IP y Borrar
			# Se escoge de todo el campo de texto solo la IP
			campo1 = str(self.store1.get (treeiter, 0))
			campo2  = self.store1.get (treeiter, 1)
			num_ip = campo1[2:-5]
			borrar = campo2[0]
			print "La ip "+num_ip+", ¿borrar? "+str(borrar)+"\n"
			if re.search('True',str(borrar)):
				#si esta marcado borramos de la lista
				# y tambien lo borramos de cga-cupsd.conf
				self.borrar(num_ip)
				borrado = self.store1.remove(treeiter)
				treeiter = self.store1.get_iter_first()
			elif re.search('False',str(borrar)):
				#itera al siguiente elemento de la lista
				treeiter = self.store1.iter_next(treeiter)
		# cuando hemos actualizado el TreeStore hacemos efectivos
		# los cambios en el fichero
		#self.actualizar_mi_cupsd()
		script = DIRECTORIO + "scripts/actualizar_ips.sh"
		os.system(script)
		# Establecemos de nuevo en el campo el texto por defecto
		self.campo_ip.set_text("192.168.XXX.XXX")
		return

	#funcion utilizada en aplicar_cambios para borrar de lista_ips.txt
	def borrar (self, ip_borrar):
		# Utilizamos el fichero aux para ir copiando solo
		# lo que no queramos borrar
		print "Abrir: "+DIRECTORIO+"lista_ips.txt\n"
		print "Abrir: "+DIRECTORIO+"tmp\n"
		f = open(DIRECTORIO+'lista_ips.txt','r')
		f1 = open(DIRECTORIO+'tmp','w')
		# Leemos lineas de f, si no contienen la ip, las copiamos en f1
		for line in f.readlines():
			print "Entro "+line
			if not re.search(ip_borrar,line):
				print "La linea "+line+" de la lista no es igual a "+ip_borrar
				f1.writelines(line)
		f.close()
		f1.close()
		# Renombramos aux sustituyendo lista_ips.txt
		os.renames(DIRECTORIO+"tmp",DIRECTORIO+"lista_ips.txt")



	# Hacemos efectivos los cambios en mi fichero de configuracion
	# Si hay al menos una ip para compartir en mi_cupsd.conf
	# ponemos el estado en compartiendo a 2
	def actualizar_mi_cupsd(self):
		# usamos la variable $$$$ para controlar que hay alguna ip
		# valida y hacer que compartiendo = 2
		f1 = open(DIR_CUPSD+'cga-cupsd.conf','r')
		f2 = open(DIRECTORIO+'lista_ips.txt','r')
		f_dest = open(DIR_CUPSD+'temp','w')

		# Variable devuelta para comprobar que hay alguna
		# ip para compartir, asi controlamos para luego poner
		# self.estado a 2
		lineas_ip = 0

		# Primero copiamos lo que teniamos anteriormente
		# hasta llegar a #START IP
		while True:
			line = f1.readline()
			if line:
				if not re.search("#START IP",line):
					f_dest.write(line)
				else:
					f_dest.write("#START IP\n")
					break

		# Ponemos f1 en la linea justo cuando termina la
		# seccion de IPs, señalada por la etiqueta  #END IP
		while True:
			line = f1.readline()
			if re.search("#END IP",line):
				break


		# Copiamos todas las ips con formato:
		#    Listen XXX.XXX.XXX.XXX:631
		for line2 in f2.readlines():
			f_dest.write("BrowseAddress "+line2[:-1]+"\n")
			lineas_ip = lineas_ip + 1

		# Escribimos nuestra etiqueta de fin #END IP
		f_dest.write("#END IP\n")

		# Escribimos el resto del fichero cupsd.conf
		while True:
			line = f1.readline()
			if line:
				f_dest.write(line)
			else:
				break
		# CERRAMOS DESCRIPTORES!!!!!
		f1.close()
		f2.close()
		f_dest.close()

		# Con esto nadie se entera del cambio mua ja ja
		os.renames (DIR_CUPSD+'temp' , DIR_CUPSD+'cga-cupsd.conf')

		# Al menos estamos compartiendo con una ip
		# esciribmos estado = 2, si no estado = 0
		# Y cambiamos en el cupsd.conf original todos los 
		# 'Deny From All' por 'Allow From All'
		f = open (DIRECTORIO+'compartiendo','w')
		print "La variable lineas_ip = "+str(lineas_ip)
		if lineas_ip > 0 :
			# Estado = 2
			f.write('2')
		else:
			f.write('0')
		os.system("/etc/init.d/cups restart")
		f.close()
		return

	# Funcion asociada al clic del boton atras de la ventana
	def atras(self,widget,data=None):
		# Actualizamos los botones
		OIniciar.borrar_botones()
		OIniciar.buscar_impresora()
		# Ocultamos la ventana actual
		self.ventana_ip.hide()

	# Funcion asociada al clic del boton anadir de la ventana
	def anadir(self,widget,data=None):
		# Sacamos el texto
		campo_ip = self.campo_ip.get_text()
		# almacenamos en la variable @resultado el valor de aplicar
		# la expresion regular a la cadena de texto a introducir
		expresion_regular = "\d{1,3}\.\d{1,3}\.\d{1,3}\.\d{1,3}"
		resultado = re.search(expresion_regular, campo_ip)

		# Si no pasa la expresion... VENTANAZO!!!
		if  not resultado :
			# Establecemos el tag del texto
			self.etiqueta_error_ip.set_text("La IP introducida no es valida\n Vuelva a intentarlo"	)
			# Hacemos visible la ventana
			self.ventana_error_ip.set_transient_for(self.ventana_ip)
			self.ventana_error_ip.show()
		else:
		# Si pasa la primera expresion, comprobamos el rango
			# split parte en trozos una cadena dado un delimitador
			lista = campo_ip.split(".")
			octeto1 = int(lista[0])
			octeto2 = int(lista[1])
			octeto3 = int(lista[2])
			octeto4 = int(lista[3])
			# Tenemos los cuatro octetos
			# Comprobamos que los dos ultimos esten entre 0 y 255
			octeto1valido = octeto1>0 and octeto1<255
			octeto2valido = octeto2>=0 and octeto2<=255
			octeto3valido = octeto3>=0 and octeto3<=255
			octeto4valido = octeto4>=0 and octeto4<=255

			# Comprobamos tambien que el primero sea 192 y el segundo 168
			if not octeto1valido or not octeto2valido or not octeto3valido or not octeto4valido :
			# Si no pasa... VENTANAZO!!!
				# Establecemos la etiqueta de texto
				self.etiqueta_error_ip.set_text("La IP introducida no es valida\n Vuelva a intentarlo")
				# Hacemos visible el VENTANAZO!!!!
				self.ventana_error_ip.set_transient_for(self.ventana_ip)
				self.ventana_error_ip.show()
			else:
				# Si pasa las dos expresiones, introducimos el valor
				# como una nueva entrada del TreeStore
				# Recorremos una vez la lista_ips.txt para
				# comprobar que no exista ya la ip
				store1 = self.store.get_model()
				existe = False
				f = open(DIRECTORIO+'lista_ips.txt','r')
				for line in f.readlines():
					if  re.search (campo_ip , line):
						existe = True
				f.close()

				# Si no existia la introducimos tanto en el treeview
				# como en lista_ips.txt
				if not existe:
					#anadimos en el fichero lista_ips.txt la ip
					f = open(DIRECTORIO+'lista_ips.txt','a')
					f.write (campo_ip+"\n")
					#anadimos en el treestore
					self.store.tree_store.append(None, (campo_ip ,None))
				else:
					# Si existe... VENTANAZO!!
					self.etiqueta_error_ip.set_text("Ya se esta compartiendo impresora \n con dicha ip")
					self.ventana_error_ip.show()
		return

	def destroy_cb(self, *kw):
		""" Destroy callback to shutdown the app """
		gtk.main_quit()
		return

	def	cerrar_ventana_error_ip (self, widget,data=None):
		self.campo_ip.set_text("192.168.XXX.XXX")
		self.ventana_error_ip.hide()
		return True


	def run(self):
		""" run is called to set off the GTK mainloop """
		return

if __name__ == "__main__":
	# creamos la ventana inicial
	OIniciar = CVentanaMenu()
	# llamamos a buscar_impresora para comprobar
	# que hay una impresora conectada
	OIniciar.buscar_impresora()
	# esperamos alguna señal
	gtk.main()
	gtk.main_quit()
