#!/bin/bash


set -e 

function get_interfaces_info {
	# Esta funcion imprime el nombre de un fichero temporal creado para 
	# almacenar por cada interfaz: 
	#    ip/subredes:broadcast:nombre_interfaz

	MY_FILE=$1
	ip a|grep -v "127.0.0.1"|grep "inet "|	awk -F" " '{ print $2":"$4":" $7 }'>$MY_FILE
	#for VAR in $(cat ${MY_FILE})
	#do
	#	echo $VAR
	#done
	#echo -n $MY_FILE 
	return 0
}


function browse_printers {
	# Esta funcion se encarga de sacar las subredes de cada interface
	# del archivo pasado como parametro y de compartir una sola vez por cada interface
	# Recibe dos parámetros:
	#  $1:  archivo en el que hay una linea por interface con el formato:
	#     ip/subredes:broadcast:nombreInterfaz
	#  $2:  nombre del archivo de configuración de cups.
	#       por defecto será /etc/cups/cga-cupsd.conf

	INFO_FILE="$1"
	MYCUPSD="$2"
	
	echo "# Archivo de extension de cupsd.conf">$MYCUPSD
	echo ''>>$MYCUPSD
	echo 'Browsing On'>>$MYCUPSD
	echo 'BrowseOrder allow,deny'>>$MYCUPSD

	for LINE in `cat ${INFO_FILE}`
	do
		# sacamos de cada linea del fichero los datos de cada subred
		IP=`echo ${LINE} | cut -d ":" -f "1"|cut -d "/" -f "1"`
		BROADCAST=`echo ${LINE} | cut -d ":" -f "2"`
		IFACE=`echo ${LINE} | cut -d ":" -f "3"`
		logger -t cga-comparte-impresoras "Compartiendo por iface $IFACE  con broadcast $BROADCAST"
		STR="${BROADCAST}:631#${IFACE}"
		echo "BrowseAddress $STR">>$MYCUPSD
	done
	echo "">>$MYCUPSD
	echo "<Location />">>$MYCUPSD
	echo ' Order allow, deny'>>$MYCUPSD 
	echo " Allow from @LOCAL ">>$MYCUPSD
	echo "</Location>">>$MYCUPSD
	echo "">>$MYCUPSD
	echo '#START IP'>> $MYCUPSD
	echo '#END IP'>>$MYCUPSD
	return 0
}

	#############################
	#           main            #
	#############################


if [ $1 ] ;then
	MYCUPSD=$1
else
	MYCUPSD='/etc/cups/cga-cupsd.conf'
fi

INFO_FILE=`mktemp`
#echo "Creado $INFO_FILE"
#echo "Ejecutando get_interfaces_info"
get_interfaces_info $INFO_FILE

# usando el archivo temporal y $MYCUPSD como archivo de configuracion
# extra para cupsys compartirá por todas las interfaces activas
browse_printers $INFO_FILE $MYCUPSD 

# se reinicia el servicio cups para que cargue la nueva configuración
/etc/init.d/cups restart > /dev/null
CUPSYS_EXIT=$?
if [ $CUPSYS_EXIT -eq 0 ] ;then
	logger -t cga-comparte-impresoras "Reiniciado cupsys sin errores"
else
	logger -t cga-comparte-impresoras "Error al reiniciar cupsys. Codigo de error $CUPSYS_EXIT"
fi

rm  -rf $INFO_FILE
exit 0
